
import java.sql.*;
import java.util.*;

public class AlbumDB extends Album
{
    protected static Connection dbConnect=null;
    public static Exception erreur=null;
    /** Creates a new instance of AlbumDB */
    
    public AlbumDB()
    {
    }
    
    public AlbumDB(int id_groupe,String nom_album,int nbre_piste,int annee_sortie)
    {
        super(id_groupe,nom_album,nbre_piste,annee_sortie);
        ajouter();
    }
    
    public AlbumDB(int id_album,int id_groupe,String nom_album,int nbre_piste,int annee_sortie)
    {
        super(id_album,id_groupe,nom_album,nbre_piste,annee_sortie);
    }
    
    public static void setConnection(Connection nouvdbConnect) 
    {
      	dbConnect=nouvdbConnect;
    }    
    public void ajouter()
    {
        erreur = null;		
    	try
    	{
	 	String req = "INSERT INTO album (id_groupe,nom_album,nbre_piste,annee_sortie)values(?,?,?,?)";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setInt(1,id_groupe);
	     	pstm.setString(2,nom_album);
	     	pstm.setInt(3,nbre_piste);
                pstm.setInt(4,annee_sortie);
	     	pstm.executeUpdate();
	     	pstm.close();
	 	}
	    catch(Exception e)
	    {
	  	  	erreur=e;
	  	}
    }
    
    protected int rechIdAlbum()
    {
    	erreur = null;
     	int m = 0;
    	try
    	{
    		String req="select id_album from album where nom_album=? and nbre_piste=? and annee_sortie=?";
    		PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setString(1,nom_album);
	        pstm.setInt(2,nbre_piste);
	        pstm.setInt(3,annee_sortie);
    		ResultSet rs = pstm.executeQuery();
    		if(rs.next()) 
    			m= rs.getInt(1);
    		else 
    			m=0;
    		pstm.close();
    		return m; 
    	}
    	catch(Exception e)
    	{
            erreur= e;
    		return -1;
    	}
    }
    
    public static AlbumDB rechIdAlbum(int nRech)
	{
		String	nom_album="+inconnu+";
		int id_groupe=0;
		int nbre_piste=0;
		int annee_sortie=0;
		erreur = null;
		try
		{
                    String req = "select * from album where id_album=?";	
                    PreparedStatement pstm = dbConnect.prepareStatement(req);
                    pstm.setInt(1,nRech);
                    ResultSet rs = pstm.executeQuery();
	     	if(rs.next())
	     	{
                        id_groupe=rs.getInt("id_groupe");
	     		nom_album=rs.getString("nom_album");
	     		nbre_piste=rs.getInt("nbre_piste");
                        annee_sortie=rs.getInt("annee_sortie");
	        	pstm.close();
	        	AlbumDB alb = new AlbumDB(nRech,id_groupe,nom_album,nbre_piste,annee_sortie);
	        	return alb;	      
	      	}
	     	else
	     	{ 
	     		pstm.close();
	            throw new Exception("id inconnu");
	      	}
		}
	
		catch(Exception e)
		{
			erreur =e;
			return null;
		}
		
	}
    
        public static Vector rechNomAlbum(String nomrech)
	{
	    Vector plusieurs=new Vector();
	    String req = "select * from album where nom_album=?";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setString(1,nomrech);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
                        int id_album=rs.getInt("id_album");
	        	int id_groupe=rs.getInt("id_groupe");
	     		String nom_album=rs.getString("nom_album");
	     		int nbre_piste=rs.getInt("nbre_piste");
                        int annee_sortie=rs.getInt("annee_sortie");
	       		plusieurs.add(new AlbumDB(id_album,id_groupe,nom_album,nbre_piste,annee_sortie));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
		
	    return plusieurs;
	}
        
        public void supprimer()
   	{
		erreur=null;
		int nl=0;
		try
		{
		 String req = "delete from album where id_album=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,id_album);
	     	nl = pstm.executeUpdate();
	     	pstm.close();
	     	if(nl==0) throw new Exception("aucune ligne  effac�e");
	    }	
	    catch (Exception e)
	    {
	     	erreur =e;
	    }
   	}
        
        public void modifier()
	{
	    erreur = null;		
    	try
    	{
	 	String req = "update album set nom_album=?,nbre_piste=?,annee_sortie=? where id_album=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
		pstm.setString(1,nom_album);
		pstm.setInt(2,nbre_piste);
	    	pstm.setInt(3,annee_sortie);
                pstm.setInt(4,id_album);
	     	int nl= pstm.executeUpdate();
	     	if(nl==0)throw new Exception("aucune ligne mise à jour");
	     	pstm.close();
	  	}
	    catch(Exception e)
	    {
	  		erreur=e;
	  	}
	} 
        
         public static Vector rechAllAlbum()
	{ Vector plusieurs=new Vector();
	String req = "select * from album";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
                        int id_album=rs.getInt("id_album");
	        	int id_groupe=rs.getInt("id_groupe");
	     		String nom_album=rs.getString("nom_album");
                        int nbre_piste=rs.getInt("nbre_piste");
                        int annee_sortie=rs.getInt("annee_sortie");
	     		plusieurs.add(new AlbumDB(id_album,id_groupe,nom_album,nbre_piste,annee_sortie));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
		
	    return plusieurs;
	}
         
         
         public static void rechAllAlbumByIdGroupe(int id_grp)
	{ Vector plusieurs=new Vector();
	    String req = "select * from album where id_groupe=?";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,id_grp);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
	        	int id_album=rs.getInt("id_album");
                        int id_groupe=rs.getInt("id_groupe");
	     		String nom_album=rs.getString("nom_album");
	     		int nbre_piste=rs.getInt("nbre_piste");
                        int annee_sortie=rs.getInt("annee_sortie");
                        System.out.println("- "+nom_album+" - annee : "+annee_sortie);
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
	}
}
