
import java.sql.*;
import java.util.*;

public class GroupeDB extends Groupe
{
	protected static Connection dbConnect=null;
    public static Exception erreur=null;
    
    public GroupeDB()
    {
   	}
   	   		
    public GroupeDB(String nom_groupe,String status,String pays,int nbre_zicos)
    {	
		super(nom_groupe,status,pays,nbre_zicos);
                ajouter();
                
    }
    
    public GroupeDB(int id_groupe,String nom_groupe,String status,String pays,int nbre_zicos)
    {	
		super(id_groupe,nom_groupe,status,pays,nbre_zicos);
    }
    
    public static void setConnection(Connection nouvdbConnect) 
    {
      	dbConnect=nouvdbConnect;
    }    
    public void ajouter()
    {
        erreur = null;		
    	try
    	{
	 	String req = "INSERT INTO groupe (nom_groupe,status,pays,nbre_musiciens)values(?,?,?,?)";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setString(1,nom_groupe);
	     	pstm.setString(2,status);
	     	pstm.setString(3,pays);
                pstm.setInt(4,nbre_zicos);
	     	pstm.executeUpdate();
	     	pstm.close();
	 	}
	    catch(Exception e)
	    {
	  	  	erreur=e;
	  	}
    }
    
            public void ajoutofficie(int id_genre,int id_groupe)
        {
            erreur = null;		
    	try
    	{
	 	String req = "INSERT INTO officie (id_genre,id_groupe)values(?,?)";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setInt(1,id_genre);
	     	pstm.setInt(2,id_groupe);
	     	pstm.executeUpdate();
	     	pstm.close();
	 	}
	    catch(Exception e)
	    {
	  	  	erreur=e;
	  	}
        }
    
    public int rechGroupeGenre(int id_groupe)
    {
        erreur = null;
     	int m = 0;
    	try
    	{
    		String req="select id_genre from officie where id_groupe=?";
    		PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setInt(1,id_groupe);
    		ResultSet rs = pstm.executeQuery();
    		if(rs.next()) 
    			m= rs.getInt(1);
    		else 
    			m=0;
    		pstm.close();
    		return m; 
    	}
    	catch(Exception e)
    	{
            erreur= e;
    		return -1;
    	}
    }
            
    public void afficher()
    {
        
    }
    
    protected int rechIdGroupe()
    {
    	erreur = null;
     	int m = 0;
    	try
    	{
    		String req="select id_groupe from groupe where nom_groupe=? and status=? and pays=? and nbre_musiciens=?";
    		PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setString(1,nom_groupe);
	        pstm.setString(2,status);
	        pstm.setString(3,pays);
                pstm.setInt(4,nbre_zicos);
    		ResultSet rs = pstm.executeQuery();
    		if(rs.next()) 
    			m= rs.getInt(1);
    		else 
    			m=0;
    		pstm.close();
    		return m; 
    	}
    	catch(Exception e)
    	{
            erreur= e;
    		return -1;
    	}
    }
    
    public static GroupeDB rechIdGroupe(int nRech)
	{
		String	nom_groupe="+inconnu+";
		String 	status="+inconnu+";
		int	nbre_zicos=0;
		String 	pays="";
		erreur = null;
		try
		{
		 	String req = "select * from groupe where id_groupe = ?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,nRech);
	     	ResultSet rs = pstm.executeQuery();
	     	if(rs.next())
	     	{
	     		nom_groupe=rs.getString("nom_groupe");
	     		status=rs.getString("status");
                        pays=rs.getString("pays");
	     		nbre_zicos=rs.getInt("nbre_musiciens");
	        	pstm.close();
	        	GroupeDB grp = new GroupeDB(nRech,nom_groupe,status,pays,nbre_zicos);
	        	return grp;	      
	      	}
	     	else
	     	{ 
	     		pstm.close();
	            throw new Exception("id inconnu");
	      	}
		}
	
		catch(Exception e)
		{
			erreur =e;
			return null;
		}
		
	}
    
        public static Vector rechNomGroupe(String nomrech)
	{
	    Vector plusieurs=new Vector();
	    String req = "select * from groupe where nom_groupe=?";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setString(1,nomrech);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
	        	int id_groupe=rs.getInt("id_groupe");
	     		String nom_groupe=rs.getString("nom_groupe");
	     		String status=rs.getString("status");
                        String pays=rs.getString("pays");
	     		int nbre_zicos=rs.getInt("nbre_musiciens");
	     		plusieurs.add(new GroupeDB(id_groupe,nom_groupe,status,pays,nbre_zicos));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
		
	    return plusieurs;
	}
        
        public void supprimer()
   	{
		erreur=null;
		int nl=0;
		try
		{
                
		String req = "delete from groupe where id_groupe=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,id_groupe);
	     	nl = pstm.executeUpdate();
	     	pstm.close();
	     	if(nl==0) throw new Exception("aucune ligne  effac�e");
	    }	
	    catch (Exception e)
	    {
                System.out.println(""+e);
	     	erreur =e;
	    }
   	}
        
        public void modifier()
	{
	    erreur = null;		
    	try
    	{
	 	String req = "update groupe set status=?,pays=?,nbre_musiciens=? where id_groupe= ?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
		pstm.setString(1,status);
		pstm.setString(2,pays);
	    	pstm.setInt(3,nbre_zicos);
                pstm.setInt(4,id_groupe);
	     	int nl= pstm.executeUpdate();
	     	if(nl==0)throw new Exception("aucune ligne mise à jour");
	     	pstm.close();
   
	  	}
	    catch(Exception e)
	    {
	  		erreur=e;
	  	}
	} 
        
        public void modifierModifier(int id_user)
        {
            erreur = null;		
            String tmp="sysdate";
    	try
    	{
	 	String req = "insert into modifie(id_utilisateur,id_groupe,date) values (?,?,current_date)";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
		pstm.setInt(1,id_user);
		pstm.setInt(2,id_groupe);
	     	int nl= pstm.executeUpdate();
	     	if(nl==0)throw new Exception("aucune ligne mise à jour");
	     	pstm.close();
                String req2 = "update modifie set date=sysdate where id_utilisateur=? and id_groupe=?";
	     	PreparedStatement pstm2 = dbConnect.prepareStatement(req2);
                pstm.setInt(1,id_user);
		pstm.setInt(2,id_groupe);
                int n2= pstm2.executeUpdate();
	     	if(n2==0)throw new Exception("aucune ligne mise à jour");
	     	pstm2.close();
	  	}
	    catch(Exception e)
	    {
                        
	  		erreur=e;
	  	}
        }
        
         public static void rechAllGroupe()
	{ Vector plusieurs=new Vector();
	String req = "select * from groupe";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
	        	int id_groupe=rs.getInt("id_groupe");
	     		String nom_groupe=rs.getString("nom_groupe");
                        String status=rs.getString("status");
                        String pays=rs.getString("pays");
                        int nbre_zicos=rs.getInt("nbre_musiciens");
                        System.out.println(""+id_groupe+" "+nom_groupe+" - pays : "+pays);
	     		//plusieurs.add(new GroupeDB(id_groupe,nom_groupe,status,pays,nbre_zicos));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
                        System.out.println(""+e);
			erreur =e;
		}
		
	    //return plusieurs;
	}
}
