import java.sql.*;
import java.util.*;

public class UtilisateurDB extends Utilisateur 
{
    protected static Connection dbConnect=null;
    public static Exception erreur=null;    
    /** Creates a new instance of UtilisateurDB */
    public UtilisateurDB()
    {
    }
    
    public UtilisateurDB(int id_question,String pseudonyme,String mdp,String email,String repquest)
    {
        super(id_question,pseudonyme,mdp,email,repquest);
        ajouter();
    }
    
    public UtilisateurDB(int id_utilisateur,int id_question,String pseudonyme,String mdp,String email,String repquest)
    {
        super(id_utilisateur,id_question,pseudonyme,mdp,email,repquest);
    }
    
    public void afficher()
    {
        
    }
    public static void setConnection(Connection nouvdbConnect) 
    {
      	dbConnect=nouvdbConnect;
    } 
    
        public void ajouter()
    {
        erreur = null;		
    	try
    	{
	 	String req = "INSERT INTO utilisateur (id_question,pseudonyme,mot_de_passe,e_mail,rep_question)values(?,?,?,?,?)";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setInt(1,id_question);
	     	pstm.setString(2,pseudonyme);
	     	pstm.setString(3,mdp);
                pstm.setString(4,email);
                pstm.setString(5,repquest);
	     	pstm.executeUpdate();
	     	pstm.close();
	 	}
	    catch(Exception e)
	    {
	  	  	erreur=e;
	  	}
    }
    
    public static int login(String user,String pass)
    {
        erreur = null;
     	int m = 0;
    	try
    	{
    		String req="select id_utilisateur from utilisateur where pseudonyme=? and mot_de_passe=?";
    		PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setString(1,user);
                pstm.setString(2,pass);
    		ResultSet rs = pstm.executeQuery();
    		if(rs.next()) 
    			m= rs.getInt(1);
    		else 
    			m=-1;
    		pstm.close();
    		return m; 
    	}
    	catch(Exception e)
    	{
            System.out.println(""+e);
            erreur= e;
    		return -1;
    	}
    }
    
    
    
    protected int rechIdUtilisateur()
    {
    	erreur = null;
     	int m = 0;
    	try
    	{
    		String req="select id_utilisateur from utilisateur where id_question=? and pseudonyme=? and mot_de_passe=? and e_mail=? and rep_question=?";
    		PreparedStatement pstm = dbConnect.prepareStatement(req);
                pstm.setInt(1,id_question);
                pstm.setString(2,pseudonyme);
	        pstm.setString(3,mdp);
	        pstm.setString(4,email);
                pstm.setString(5,repquest);
    		ResultSet rs = pstm.executeQuery();
    		if(rs.next()) 
    			m= rs.getInt(1);
    		else 
    			m=0;
    		pstm.close();
    		return m; 
    	}
    	catch(Exception e)
    	{
            erreur= e;
    		return -1;
    	}
    }
    
    public static UtilisateurDB rechIdUtilisateur(int nRech)
	{
		String	pseudonyme="+inconnu+";
		String 	mdp="+inconnu+";
                String email="+inconnu+";
		String repquest="+inconnu+";
		int id_question=0;
		erreur = null;
		try
		{
		 	String req = "select * from utilisateur where id_utilisateur=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,nRech);
	     	ResultSet rs = pstm.executeQuery();
	     	if(rs.next())
	     	{
                        id_question=rs.getInt("id_question");
	     		pseudonyme=rs.getString("pseudonyme");
	     		mdp=rs.getString("mot_de_passe");
                        email=rs.getString("e_mail");
	     		repquest=rs.getString("rep_question");
	        	pstm.close();
	        	UtilisateurDB user = new UtilisateurDB(nRech,id_question,pseudonyme,mdp,email,repquest);
	        	return user;	      
	      	}
	     	else
	     	{ 
	     		pstm.close();
	            throw new Exception("id inconnu");
	      	}
		}
	
		catch(Exception e)
		{
			erreur =e;
			return null;
		}
		
	}
    
        public static Vector rechNomUtilisateur(String nomrech)
	{
	    Vector plusieurs=new Vector();
	    String req = "select * from utilisateur where pseudonyme=?";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setString(1,nomrech);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
	        	int id_utilisateur=rs.getInt("id_utilisateur");
	     		int id_question=rs.getInt("id_question");
                        String pseudonyme=rs.getString("pseudonyme");
	     		String mdp=rs.getString("mot_de_passe");
                        String email=rs.getString("e_mail");
	     		String repquest=rs.getString("rep_question");
	     		plusieurs.add(new UtilisateurDB(id_utilisateur,id_question,pseudonyme,mdp,email,repquest));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
		
	    return plusieurs;
	}
        
        public void supprimer()
   	{
		erreur=null;
		int nl=0,n2=0;
		try
		{
                String req1 = "delete from modifie where id_utilisateur=?";	
	     	PreparedStatement pstm1 = dbConnect.prepareStatement(req1);
	     	pstm1.setInt(1,id_utilisateur);
	     	n2 = pstm1.executeUpdate();
	     	pstm1.close();
	     	if(n2==0) throw new Exception("aucune ligne  effac�e");    
                    
		String req = "delete from utilisateur where id_utilisateur=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	pstm.setInt(1,id_utilisateur);
	     	nl = pstm.executeUpdate();
	     	pstm.close();
	     	if(nl==0) throw new Exception("aucune ligne  effac�e");
                }	
                catch (Exception e)
                {
                    System.out.println(""+e);
                    erreur =e;
                }
   	}
        
        public void modifier(int id_utilisateur)
	{
	    erreur = null;		
    	try
    	{
	 	String req = "update utilisateur set id_question=?,mot_de_passe=?,e_mail=?,rep_question=? where id_utilisateur=?";	
	     	PreparedStatement pstm = dbConnect.prepareStatement(req);
		pstm.setInt(1,id_question);
		pstm.setString(2,mdp);
	    	pstm.setString(3,email);
                pstm.setString(4,repquest);
                pstm.setInt(5,id_utilisateur);
	     	int nl= pstm.executeUpdate();
	     	if(nl==0)throw new Exception("aucune ligne mise à jour");
	     	pstm.close();
	  	}
	    catch(Exception e)
	    {
	  		erreur=e;
	  	}
	} 
        
         public static Vector rechAllUtilisateur()
	{ Vector plusieurs=new Vector();
	String req = "select * from utilisateur";	
	    erreur=null;
	    try
	    {
	    	PreparedStatement pstm = dbConnect.prepareStatement(req);
	     	ResultSet rs = pstm.executeQuery();
	     	while(rs.next())
	     	{
	        	int id_utilisateur=rs.getInt("id_utilisateur");
                        int id_question=rs.getInt("id_question");
	     		String pseudonyme=rs.getString("pseudonyme");
                        String mdp=rs.getString("mot_de_passe");
                        String email=rs.getString("e_mail");
                        String repquest=rs.getString("rep_question");
	     		plusieurs.add(new UtilisateurDB(id_utilisateur,id_question,pseudonyme,mdp,email,repquest));
	      	}
	      	pstm.close();
		}
		catch(Exception e)
		{
			erreur =e;
		}
		
	    return plusieurs;
	}
}
